# elasticsearch utils 接口文档

## 医生

*   医生搜索: `search.utils.doctor.search_doctor`

        def search_doctor(
            query='', # 搜索query
            user_city_tag_id=None, # 用户所在城市tag id
            offset=0, # 偏移量
            size=5, # 返回结果个数
            sort_type=DOCTOR_ORDER_TYPE.DEFAULT, # 排序方式，参见api.models.types.DOCTOR_ORDER_TYPE
            filters={ # 过滤器
                'province_tag_id': 省份tag id,
                'bodypart_tag_id': 一级tag id,
            }
        )

*   医生过滤: `search.utils.doctor.filter_doctor`

        def filter_doctor(
            user_city_tag_id=None, # 用户所在城市tag id
            offset=0,
            size=5,
            sort_type=DOCTOR_ORDER_TYPE.DEFAULT2, # 排序方式，参见api.models.types.DOCTOR_ORDER_TYPE
            filters={ # 过滤器
                'province_tag_id': 省份tag id,
                'tag_ids': [需要过滤的tag id1, tag id2, ...] # 注意是"或"的关系
            }
        )

## 日记本

*   日记本搜索: `search.utils.diary.search_diary`

        def search_diary(
            query='', # 搜索query
            offset=0,
            size=5,
            sort_type=DIARY_ORDER_TYPE.DEFAULT, # 排序方式，参见api.models.types.DIARY_ORDER_TYPE
            filters={ # 过滤器
                'province_tag_id': 省份tag id,
                'bodypart_tag_id': 一级tag id,
                'bodypart_subitem_tag_id': 二级tag id,
                'doctor_id': 医生tag id,
                'hospital_id': 医院tag id,
                'service_id': 关联福利tag id,
                'tag_ids': [需要过滤的tag id1, tag id2, ...] # 注意是"或"的关系
            }
        )

*   日记本过滤: `search.utils.diary.filter_diary`

        def filter_diary(
            offset=0,
            size=5,
            sort_type=DIARY_ORDER_TYPE.LAST_UPDATE_TIME, # 排序方式，参见api.models.types.DIARY_ORDER_TYPE
            filters={ # 过滤器
                'province_tag_id': 省份tag id,
                'doctor_id': 医生tag id,
                'hospital_id': 医院tag id,
                'service_id': 关联福利tag id,
                'tag_ids': [需要过滤的tag id1, tag id2, ...] # 注意是"或"的关系
            },
            nfilters={ # 反向过滤器（满足条件的会被筛除）
                'id': 需要排除的日记本id,
            }
        )

## 百科

*   百科搜索: `search.utils.itemwiki.search_itemwiki`

        search_itemwiki(
            query='', # 搜索query
            offset=0,
            size=5
        )

## 福利

*   福利搜索: `search.utils.service.search_service`

        def search_service(
            query='', # 搜索query
            user_city_tag_id=None, # 用户所在城市tag id
            offset=0,
            size=5,
            sort_type=SERVICE_ORDER_TYPE.DEFAULT, # 排序方式，参见api.models.types.SERVICE_ORDER_TYPE
            filters={
                'province_tag_id': 省份tag id,
                'bodypart_tag_id': 一级tag id,
            }
        )

*   福利过滤: `search.utils.service.filter_service`

        def filter_service(
            user_city_tag_id=None, # 用户所在城市tag id
            offset=0,
            size=5,
            sort_type=SERVICE_ORDER_TYPE.DEFAULT, # 排序方式，参见api.models.types.SERVICE_ORDER_TYPE
            filters={
                'channel': 频道,
                'doctor_id': 关联医生id,
                'hospital_id': 关联医院id,
                'tag_ids': [需要过滤的tag id1, tag id2, ...] # 注意是"或"的关系
            }
        )

## tag/圈子

*   tag搜索: `search.utils.tag.search_tag`

        search_tag(
            query='', # 搜索query
            offset=0,
            size=5
        )

## 帖子

*   帖子搜索: `search.utils.topic.search_topic`

        search_topic(
            query='', # 搜索query
            offset=0,
            size=5
        )

*   帖子过滤: `search.utils.topic.filter_topic`

        def filter_topic(
            offset=0,
            size=5,
            sort_type=PROBLEM_ORDER_TYPE.DEFAULT,
            filters={
                'tag_ids': [需要过滤的tag id1, tag id2, ...] # 注意是"或"的关系,
                'is_elite': True, # 会筛选出标记了"所长精选"或"热门推荐",
                'topic_type': 帖子类型,
            }
        )
